/* -*- C++ -*-
 * src/test/graph_wrapper_test.cc - Part of LEMON, a generic C++ optimization library
 *
 * Copyright (C) 2005 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
 * (Egervary Combinatorial Optimization Research Group, EGRES).
 *
 * Permission to use, modify and distribute this software is granted
 * provided that this copyright notice appears in all copies. For
 * precise terms see the accompanying LICENSE file.
 *
 * This software is provided "AS IS" with no warranty of any kind,
 * express or implied, and with no claim as to its suitability for any
 * purpose.
 *
 */

#include<iostream>
#include<lemon/concept_check.h>

#include<lemon/smart_graph.h>
#include<lemon/concept/graph.h>

#include<lemon/list_graph.h>
#include<lemon/full_graph.h>
#include<lemon/graph_wrapper.h>

#include"test/test_tools.h"
#include"test/graph_test.h"

/**
\file
This test makes consistency checks of graph wrappers.

\todo More extensive tests are needed 
*/

using namespace lemon;
using namespace lemon::concept;



int main() 
{
  {
    typedef StaticGraph Graph;
    checkConcept<StaticGraph, GraphWrapper<Graph> >();

    checkConcept<StaticGraph, RevGraphWrapper<Graph> >();

    checkConcept<StaticGraph, SubGraphWrapper<Graph, 
      Graph::NodeMap<bool> , Graph::EdgeMap<bool> > >();
    checkConcept<StaticGraph, NodeSubGraphWrapper<Graph, 
      Graph::NodeMap<bool> > >();
    checkConcept<StaticGraph, EdgeSubGraphWrapper<Graph, 
      Graph::EdgeMap<bool> > >();
    
    checkConcept<StaticGraph, SubBidirGraphWrapper<Graph, 
      Graph::EdgeMap<bool>, Graph::EdgeMap<bool> > >();
    //    checkConcept<StaticGraph, BidirGraph<Graph> >();
    checkConcept<StaticGraph, ResGraphWrapper<Graph, int, 
      Graph::EdgeMap<int>, Graph::EdgeMap<int> > >();

    checkConcept<StaticGraph, ErasingFirstGraphWrapper<Graph, 
      Graph::NodeMap<Graph::Edge> > >(); 
  }
  std::cout << __FILE__ ": All tests passed.\n";

  return 0;
}
